#!/usr/bin/env python
# -*- coding: utf-8 -*-

#License GPL
#amk.py
#Version 0.2.5
#Author Fabrizio Ruggeri
#Contact: fabrizio.ruggeri@gmail.com

from qt import *
import sys
import os
#from form import AmuleKform


class AmuleKform(QWidget):
    def __init__(self,parent = None,name = None,fl = 0):
        QWidget.__init__(self,parent,name,fl)

        if not name:
            self.setName("Form1")


        Form1Layout = QGridLayout(self,1,1,11,6,"Form1Layout")

        layout4 = QVBoxLayout(None,0,6,"layout4")

        layout18 = QVBoxLayout(None,0,6,"layout18")

        self.textLabel1 = QLabel(self,"textLabel1")
        layout18.addWidget(self.textLabel1)

        self.listView1 = QListView(self,"listView1")
        self.listView1.addColumn(self.__tr("File Name"))
        self.listView1.addColumn(self.__tr("Ed2k Link"))
        layout18.addWidget(self.listView1)
        layout4.addLayout(layout18)

        layout19 = QHBoxLayout(None,0,6,"layout19")

        self.sendButton = QPushButton(self,"sendButton")
        layout19.addWidget(self.sendButton)

        self.progressBar2 = QProgressBar(self,"progressBar2")
        self.progressBar2.setEnabled(0)
        layout19.addWidget(self.progressBar2)

        self.textLabel1_2 = QLabel(self,"textLabel1_2")
        self.textLabel1_2.setEnabled(0)
        layout19.addWidget(self.textLabel1_2)
        spacer6 = QSpacerItem(132,39,QSizePolicy.Expanding,QSizePolicy.Minimum)
        layout19.addItem(spacer6)

        self.exitButton = QPushButton(self,"exitButton")
        layout19.addWidget(self.exitButton)
        layout4.addLayout(layout19)

        Form1Layout.addLayout(layout4,0,0)

        self.languageChange()

        self.resize(QSize(851,589).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.exitButton,SIGNAL("clicked()"),self.close)


    def languageChange(self):
        self.setCaption(self.__tr("Form1"))
        self.textLabel1.setText(self.__tr("<b>Extracetd ed2k link<font size=\"+1\"></font></b>"))
        self.listView1.header().setLabel(0,self.__tr("File Name"))
        self.listView1.header().setLabel(1,self.__tr("Ed2k Link"))
        self.sendButton.setText(self.__tr("Send to &aMule"))
        self.sendButton.setAccel(QKeySequence(self.__tr("Alt+A")))
        self.textLabel1_2.setText(self.__tr("<b>Succesfully Sended</b>"))
        self.exitButton.setText(self.__tr("E&xit"))
        self.exitButton.setAccel(QKeySequence(self.__tr("Alt+X")))


    def __tr(self,s,c = None):
        return qApp.translate("AmuleKform",s,c)


#Questa classe eredita il form creato col designer
class MyForm(AmuleKform):
	
	itemNumber = 0
	def __init__(self):
		AmuleKform.__init__(self)
		self.connect(self.sendButton,SIGNAL('clicked()'), self.sendToMule)
		
	#Aggiungiamo un funzione per inserire elementi nel form che prende due stringhe
	
	def fillListView(self,nome,elink):
		item = QCheckListItem(self.listView1,"Selected",QCheckListItem.CheckBox)
		item.setText(0,nome+"  ")
		item.setText(1,elink)
		item.setOn(True)
	
	def adjust(self):
		self.adjustSize()
		self.itemNumber = self.itemNumber + 1
		self.progressBar2.setTotalSteps(self.itemNumber)
		#self.checkBox1.setChecked(True)
		#self.connect(self.checkBox1,SIGNAL('pressed()'),self.selectAllNone)
		
		
	
	def selectAllNone(self):
		itemList=QListViewItemIterator(self.listView1)
		i=0
		while (itemList.current()):
			i += 1
			if ( itemList.current().isOn() == True ):
				itemList.current().setOn(True)
			else:
				itemList.current().setOn(False)
			itemList += 1
		
	#Questa funzione legge da ogni riga la seconda colonna(il link) e lo invia ad aMule
	def sendToMule(self):
		self.progressBar2.setEnabled(1)
		itemList=QListViewItemIterator(self.listView1)
		i=0
		while (itemList.current()):
			i += 1
			if ( itemList.current().isOn() == True ):
				os.popen('ed2k \"'+itemList.current().text(1).__str__().encode('utf8')+'\"')
			self.progressBar2.setProgress(i)
			itemList += 1
		self.textLabel1_2.setEnabled(1)
			
		
	


if __name__ == "__main__":
	app = QApplication(sys.argv)
	myf = MyForm()

#Vediamo se il file e' binario o di testo
	f = os.popen('file -bi '+sys.argv[1],'r')
	if (f.read().find('text') != -1) == False :
	#in questo caso il file e' binario e dobbiamo darlo in pasto a amule_emc
		print sys.argv[1]
		os.popen('amule_emc '+ sys.argv[1] +'>'+os.path.expanduser('~')+"/.deleteMe")
		try:
			binaryfile = open (os.path.expanduser('~')+"/.deleteMe")   
	#Apre il file creato dallo script
		except IOError:
			os.popen('kdialog --error \"I can\'t read this collection file\\nCheck if it\'s corrupted\"')
			quit()
		try:    #Estrae nome del file e link e le aggiunge al form come elementi
			for link in binaryfile:
				name = link[link.find("ed2k://|file|")+13:link.find("|",link.find("ed2k://|file|")+13)]
				myf.fillListView(name,link)
			myf.adjust()
		finally:
			binaryfile.close()
	#Se invece non è binario	
	else:
		try:
			textfile = open(sys.argv[1],'r')
		except IOError:
			os.popen('kdialog --error \"I can\'t read this collection file\\nCheck if it\'s corrupted\"')
			quit()
		try:
			for link in textfile:
				name = link[link.find("ed2k://|file|")+13:link.find("|",link.find("ed2k://|file|")+13)]
				myf.fillListView(name,link)
			myf.adjust()
		finally:
			textfile.close()
	
	f.close()
	
	
	myf.show()
	app.setMainWidget(myf)
	app.exec_loop()